// Aloha.cpp: implementation of the CAloha class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "Aloha.h"
#include "event.h"
#include "EventManager.h"
#include "BWSim.h"
#include "dialog1.h"
#include "poisson.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CBWSim bwsim;
extern CEventManager event_manager;
extern CDialog1 dlg_list;

//....................................................

CAloha::CAloha()
{

}

//....................................................

CAloha::~CAloha()
{

}

//....................................................

bool CAloha::Init(double current_time)
{
	m_occupied=false;
	m_clashed=false;
	m_endtime=0;
	alpha=0.1;

	//____Set the slot time for the sources

	for(int i=0;i<MAX_NSRC;i++)
	if(IsAllocated[i]==1)
	{
		(ds_array[i])->m_packetduration=bwsim.GetTimeMult(bw_avail,(ds_array[i])->m_packetlength);
		//AfxMessageBox(bwsim.itos((ds_array[i])->m_packetlength));
	}

	return true;

}

//....................................................

void CAloha::Send(double current_time)
{
	if(bwsim.m_currentevent->m_event_type==PACKET_SEND_END)
	{

		//__________Do statistics part___

		int _id=bwsim.m_currentevent->m_data;
		ds_array[_id]->SendPacket();
		m_occupied=false;
		m_clashed=false;
	}

	//__________If no collision___

	else if(bwsim.m_currentevent->m_event_type==PACKET_NOTIFY)
	{
		if(m_clashed) //_____IF clashed
		{
			bwsim.m_ds[bwsim.m_currentevent->m_data]->Dropped(bwsim.m_currentevent->m_origintime);
			return;
		}

		CEvent* _event=new CEvent;
		(*_event)=(*bwsim.m_currentevent);
		_event->m_event_type=PACKET_SEND_END;
		event_manager.AddEvent(_event);
	}
	else if(bwsim.m_currentevent->m_event_type==PACKET_FINISH) //________Schedule this packet for some other time____
	{

		//________Update occupied state___
		//		dlg_list.m_list.AddString("current_time:"+bwsim.dtos(current_time));
		//		dlg_list.m_list.AddString("end_time:"+bwsim.dtos(m_endtime));

		if(current_time>m_endtime)
		{
			m_occupied=false;
			m_clashed=false;
		}

		//______________________________

		CEvent* _event1=new CEvent;
		CEvent* _event=bwsim.m_currentevent;
		int _id=bwsim.m_ds[_event->m_data]->nms_id;  //_______Its position in IsAllocated Array

		//_____i contains the slot no.

		double _slottime=current_time;
		_event1->m_duration=bwsim.GetTimeMult(bw_avail,ds_array[_id]->m_packetlength);

		m_endtime=(_event1->m_time=_slottime+_event1->m_duration-1);

		//________Check if other packets are there for transmission at the same time

		for(int i=0;i<MAX_NSRC;i++)
		{
			if(IsAllocated[i]==1)
			{
				if(ds_array[i]->IsPacketBurst(current_time))
					if(i!=_id)
						m_occupied=true;
			}
		}

		if(m_occupied)
		{

			//			if(!m_clashed) //________2nd source to collide to notify the first source to drop packet
			//			{
			//				bwsim.m_ds[m_firstclashds.m_data]->Dropped(m_firstclashds.m_origintime);
			//				AfxMessageBox(bwsim.itos(m_firstclashds.m_data)+"  " + bwsim.itos(_id));
			//				AfxMessageBox("\n\n"+bwsim.itos(m_firstclashds.m_origintime)+"  "+bwsim.itos(current_time));
			//			}

			m_clashed=true; // Update state info
			ds_array[_id]->Dropped(bwsim.m_currentevent->m_origintime); // Inform the ds!!
			delete _event1;
			return;
		}

		//_____Not occupied yet___

		_event1->m_event_type=PACKET_NOTIFY;
		_event1->m_data=_id;
		_event1->m_bwlower=bwind_start;
		_event1->m_bwupper=_event1->m_bwlower+bw_avail;
		_event1->m_origintime=current_time;

		event_manager.AddEvent(_event1);

		//		m_firstclashds=*_event1;

		m_occupied=true;
	}
}

//....................................................

void CAloha::Finish(double current_time)
{

}

//....................................................

int CAloha::GetBWRequired()
{
	return 64;
}

