// BWSim.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BWSim.h"
#include "general.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "BWSimDoc.h"
#include "BWSimView.h"

//___________Include other files

#include "Error.h"
#include "EventManager.h"

#include "Event.h"

//______________Include all dialogs

#include "DSAdd.h"
#include "DSShow.h"
#include "BWShow.h"

#include "Dialog1.h"
#include "Display.h"
#include "Zoom.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBWSimApp

BEGIN_MESSAGE_MAP(CBWSimApp, CWinApp)
//{{AFX_MSG_MAP(CBWSimApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG_MAP
// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBWSimApp construction

//....................................................

CBWSimApp::CBWSimApp()
{

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance

}

	/////////////////////////////////////////////////////////////////////////////
	// The one and only CBWSimApp object

CBWSimApp theApp;

CBWSim bwsim;
CError error;
CEventManager event_manager;
CAutomation m_auto;

	//_____Dialogs

CDSAdd dlg_dsadd;
CDSShow dlg_dsshow;

CBWShow dlg_bwshow;
CDialog1 dlg_list;
CDisplay dlg_display;
CZoom dlg_zoom;

	//________pointer trick

CEvent gevent;

	/////////////////////////////////////////////////////////////////////////////
	// CBWSimApp initialization

//....................................................

BOOL CBWSimApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.

	SetRegistryKey("BWSim 1.0  -  IIT Delhi");

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BWSIMTYPE,
		RUNTIME_CLASS(CBWSimDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBWSimView));

	//	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window

	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line

	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.

	pMainFrame->ShowWindow(m_nCmdShow | SW_SHOWMAXIMIZED);
	pMainFrame->UpdateWindow();

	return TRUE;
}

	/////////////////////////////////////////////////////////////////////////////
	// CAboutDlg dialog used for App About

//....................................................

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	// Implementation

protected:

	//{{AFX_MSG(CAboutDlg)
	// No message handlers
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

//....................................................

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{

	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT

}

//....................................................

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

	// App command to run the dialog

//....................................................

void CBWSimApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

	/////////////////////////////////////////////////////////////////////////////
	// CBWSimApp commands

	//////////////////////////////////////////////////////////////////////
	// CBWSim Class
	//////////////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////////////
	// Construction/Destruction
	//////////////////////////////////////////////////////////////////////

//....................................................

CBWSim::CBWSim()
{
	m_ds.SetSize(MAX_NSRC);

	m_nstations=0;
	m_delay=0;

	m_protocols.Add("tdma");
	m_protocols.Add("fdma");
	m_protocols.Add("aloha");
	m_protocols.Add("fhop");
	m_protocols.Add("vcfhop");
	m_protocols_no=5;

	m_start=false;
}

//....................................................

CBWSim::~CBWSim()
{

}

//....................................................

void CBWSim::Reset()
{
	m_global_performance.Reset();
}

//....................................................

int CBWSimApp::ExitInstance()
{

	// TODO: Add your specialized code here and/or call the base class

	return CWinApp::ExitInstance();
}

//....................................................

CString CBWSim::itos(int i)
{
	char buffer[13];
	itoa(i,buffer,10);
	return CString(buffer);

}

//....................................................

double CBWSim::GetTimeMult(int bw,int packetsize)
{
	if(bw==0) return 0;
	return double(packetsize*1000)/(bw*1024); //________Return in milliseconds
}

//....................................................

CString CBWSim::dtos(double i,int s)
{
	char buffer[17];
	_gcvt(i,s,buffer);
	CString t=buffer;
	t.TrimRight();
	if(t.Right(1)=='.')
		t=t.Left(t.GetLength()-1);

	return t;
}

//....................................................

CPerformance::CPerformance()
{
	Reset();
}

//....................................................

CPerformance::~CPerformance()
{
}

//....................................................

void CPerformance::Reset()
{
	m_bytes_attempted=0;
	m_packets_attempted=0;
	m_bytes_sent=0;
	m_packets_sent=0;
	m_average_delay=0;

	m_packets_ideal=0;
	m_bytes_ideal=0;
}

//....................................................

bool CBWSim::AddDataSource(CDataSource* ds)
{
	ds->m_id=m_nstations;
	m_ds.InsertAt(m_nstations++,ds);
	return true;
}

//....................................................

bool CBWSim::DeleteDataSource(short no)
{
	if(m_nstations>no)
	{
		delete bwsim.m_ds[no];
		bwsim.m_ds.RemoveAt(no,1);
		m_nstations--;
		return true;
	}
	else
		return false;

}

//....................................................

void CAutomation::Reset()
{
	started=false;
	duration=0;
	time=0;
	current_trial=0;
	trials=0;

}

//....................................................

CAutomation::CAutomation()
{
	Reset();
}
