// BWSim.h : main header file for the BWSIM application
//

#if !defined(AFX_BWSIM_H__DF3685E5_3694_11D4_B59C_005004BF2FFA__INCLUDED_)
#define AFX_BWSIM_H__DF3685E5_3694_11D4_B59C_005004BF2FFA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

//____________other includes

#include "datasource.h"
#include "general.h"
#include "nms.h"
#include "Event.h"	// Added by ClassView

/////////////////////////////////////////////////////////////////////////////
// CBWSimApp:
// See BWSim.cpp for the implementation of this class
//

//....................................................

class CBWSimApp : public CWinApp
{
public:
	CBWSimApp();

	CEvent m_currentevent;

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBWSimApp)
public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	// Implementation

	//{{AFX_MSG(CBWSimApp)
	afx_msg void OnAppAbout();

	// NOTE - the ClassWizard will add and remove member functions here.
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

	/////////////////////////////////////////////////////////////////////////////

class CPerformance
{
public:

	//__________statistics variables

	double m_packets_attempted;
	double m_bytes_attempted;
	double m_packets_sent;
	double m_bytes_sent;

	double m_packets_ideal;
	double m_bytes_ideal;

	double m_average_delay;

	CPerformance();
	virtual ~CPerformance();
	void Reset();
};

class CAutomation
{
public:
	CString m_title;
	CAutomation();
	short trials;
	short current_trial;
	void Reset();
	bool started;
	double duration;
	double time;

};

class CBWSim
{
public:
	bool DeleteDataSource(short no);
	bool AddDataSource(CDataSource* ds);

	CString dtos(double i,int s=10);
	double GetTimeMult(int bw=0,int packetsize=PACKETSIZE);
	CString itos(int i);

	//________temp info

	long m_lastevent;
	int m_delay;
	int	m_nstations;
	bool m_start;
	bool m_paused;
	double m_currenttime;
	CEvent* m_currentevent;
	CArray<CDataSource*,CDataSource*> m_ds ;
	CNMS m_nms;

	//__________statistics variables

	CPerformance m_global_performance;

	//_______Permanent info___

	int m_bwwidth;
	int m_dswidth;

	//____________usec per pixel____________

	int m_dsusec;
	int m_bwusec;

	//__________Protocols Available for data sources__

	CArray<CString,CString> m_protocols;
	CString m_defaultprotocol;
	short m_protocols_no;



	

	//______________Format data________

	CBWSim();
	virtual ~CBWSim();
	void Reset();

};

	//{{AFX_INSERT_LOCATION}}
	// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BWSIM_H__DF3685E5_3694_11D4_B59C_005004BF2FFA__INCLUDED_)
