// DSShow.cpp : implementation file
//

#include "stdafx.h"
#include "BWSim.h"
#include "DSShow.h"
#include "memdc.h"
#include "Dialog1.h"
#include "event.h"
#include "eventmanager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CDialog1 dlg_list;

/////////////////////////////////////////////////////////////////////////////
// CDSShow dialog

//#define HGAP 5

#define VGAP 30
#define USEC 10  //__________No of usec per pixel

extern CBWSim bwsim;

extern CEventManager event_manager;

//....................................................

CDSShow::CDSShow(CWnd* pParent /*=NULL*/)
: CDialog(CDSShow::IDD, pParent)
{

	//{{AFX_DATA_INIT(CDSShow)

	m_hscroll = 0;
	m_vscroll = 0;
	//}}AFX_DATA_INIT

}

//....................................................

void CDSShow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CDSShow)

	DDX_Control(pDX, IDC_VSCROLL, m_ctrl_vscroll);
	DDX_Control(pDX, IDC_HSCROLL, m_ctrl_hscroll);
	DDX_Scroll(pDX, IDC_HSCROLL, m_hscroll);
	DDX_Scroll(pDX, IDC_VSCROLL, m_vscroll);
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CDSShow, CDialog)
	//{{AFX_MSG_MAP(CDSShow)
	ON_WM_PAINT()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

	/////////////////////////////////////////////////////////////////////////////
	// CDSShow message handlers

//....................................................

void CDSShow::OnPaint()
{

	CPaintDC pDC(this);
	CMemDC memDC( &pDC, m_ScrollWindow, m_RectWindow, &m_BufferBackground );
	CDC* dc=memDC.GetSafeCDC();

	// TODO: Add your message handler code here
	//________________Draw the packet window_____________

	CPen PenRed(PS_SOLID,1,RGB(255,0,0));
	CBrush BrushRed(RGB(255,0,0));

	//____________Set Text attributes_______________

	dc->SelectObject(m_smallfont);
	dc->SetTextColor(RGB(255,0,0));
	dc->SetBkMode(TRANSPARENT);

	//_____Fill with black color

	CBrush Brush(RGB(0,0,0));
	dc->FillRect(m_ScrollWindow,&Brush);

	int hgap,vgap,ycord;

	//_______Feasible only if nsrcs > 0

	int i,j;

	vgap=30;
	hgap=1;

	dc->SelectObject(&PenDark);
	dc->SelectObject(&BrushRed);

	//______Draw HLines

	ycord=VGAP;
	dc->SelectObject(PenDark);

	for(i=0;i<bwsim.m_nstations;i++)
	{
		dc->MoveTo(0,ycord);
		dc->LineTo(xmax,ycord);

		//___________write dsource no

		dc->TextOut(1,ycord-30+2,bwsim.itos(i+1));

		//________write delay statistics

		dc->TextOut(1,ycord-30+12,bwsim.itos(bwsim.m_ds[i]->m_averagedelay));

		ycord+=VGAP;
	}

	//_____Draw VLine

	dc->MoveTo(30,0);
	dc->LineTo(30,ymax);

	//_____Draw Boxes_____

	int state;
	DrawPacket(j,i,state,dc); //_____Draw all the packets

	//_______Now draw everything

	UpdateData(true);
	memDC.CopyToScreen(0,m_hscroll,m_vscroll);

	// Do not call CDialog::OnPaint() for painting messages

}

//....................................................

BOOL CDSShow::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	GetDlgItem(IDC_WINDOW)->GetWindowRect(&m_RectWindow);
	ScreenToClient(&m_RectWindow);
	m_RectWindow.DeflateRect(2,2);

	//____Init Pens_____________

	PenDark.CreatePen(PS_SOLID,1,RGB(20,57,5));
	PenBright.CreatePen(PS_SOLID,1,RGB(152,245,115));
	PenClash.CreatePen(PS_SOLID,1,RGB(248,139,50));

	BrushDark.CreateSolidBrush(RGB(20,57,5));
	BrushBright.CreateSolidBrush(RGB(152,245,115));
	BrushClash.CreateSolidBrush(RGB(248,139,50));

	//___________Create display font________

	m_displayfont.CreatePointFont(70,"Arial",NULL);
	m_smallfont.CreatePointFont(70,"Arial",NULL);

	ReInit(bwsim.m_nstations);

	return TRUE;  // return TRUE unless you set the focus to a control

	// EXCEPTION: OCX Property Pages should return FALSE
}

//....................................................

void CDSShow::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{

	// TODO: Add your message handler code here and/or call default

	SCROLLINFO ScrollInfo;
	pScrollBar->GetScrollInfo(&ScrollInfo);  // get information about the scroll

	if(pScrollBar=&m_ctrl_vscroll)
	{
		switch(nSBCode)
		{	
			case SB_BOTTOM:         //Scrolls to the lower right.
				break;

			case SB_ENDSCROLL:      //Ends scroll.
				break;

			case SB_LINEDOWN:       //Scrolls one line down.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() + 1);
				break;

			case SB_LINEUP:         //Scrolls one line up.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() - 1);
				break;

			case SB_PAGEDOWN:       //Scrolls one page down.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() + ScrollInfo.nPage);
				break;

			case SB_PAGEUP:         //Scrolls one page up.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() - ScrollInfo.nPage);
				break;

			case SB_THUMBPOSITION:  //The user has dragged the scroll box (thumb) and released the mouse button. The nPos parameter indicates the position of the scroll box at the end of the drag operation.
				break;

			case SB_THUMBTRACK:     //The user is dragging the scroll box. This message is sent repeatedly until the user releases the mouse button. The nPos parameter indicates the position that the scroll box has been dragged to.
				pScrollBar->SetScrollPos(nPos);
				break;

			case SB_TOP:            //Scrolls to the upper left.
				break;
		}
		UpdateData(true);
		InvalidateRect(m_RectWindow,FALSE);
		UpdateWindow();
	}	

	//CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

}

//....................................................

void CDSShow::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{

	// TODO: Add your message handler code here and/or call default

	SCROLLINFO ScrollInfo;
	pScrollBar->GetScrollInfo(&ScrollInfo);  // get information about the scroll

	if(pScrollBar=&m_ctrl_hscroll)
	{
		switch(nSBCode)
		{
			case SB_BOTTOM:         //Scrolls to the lower right.
				break;

			case SB_ENDSCROLL:      //Ends scroll.
				break;

			case SB_LINEDOWN:       //Scrolls one line down.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() + 1);
				break;

			case SB_LINEUP:         //Scrolls one line up.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() - 1);
				break;

			case SB_PAGEDOWN:       //Scrolls one page down.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() + ScrollInfo.nPage);
				break;

			case SB_PAGEUP:         //Scrolls one page up.
				pScrollBar->SetScrollPos(pScrollBar->GetScrollPos() - ScrollInfo.nPage);
				break;

			case SB_THUMBPOSITION:  //The user has dragged the scroll box (thumb) and released the mouse button. The nPos parameter indicates the position of the scroll box at the end of the drag operation.
				break;

			case SB_THUMBTRACK:     //The user is dragging the scroll box. This message is sent repeatedly until the user releases the mouse button. The nPos parameter indicates the position that the scroll box has been dragged to.
				pScrollBar->SetScrollPos(nPos);
				break;

			case SB_TOP:            //Scrolls to the upper left.
				break;
		}

		UpdateData(true);
		InvalidateRect(m_RectWindow,FALSE);
		UpdateWindow();

	}	
}

	//______________This function reinits the scroll sizes etc.___________

//....................................................

void CDSShow::ReInit(int _nsrc)
{

	xmax=30+DS_WIDTH+30;
	ymax=_nsrc*30;

	m_ScrollWindow.left=0;
	m_ScrollWindow.top=0;
	m_ScrollWindow.right=xmax;
	m_ScrollWindow.bottom=ymax;

	SCROLLINFO ScrollInfo;
	ScrollInfo.cbSize = sizeof(ScrollInfo);     // size of this structure
	ScrollInfo.fMask = SIF_ALL;                 // parameters to set
	ScrollInfo.nMin = 0;                        // minimum scrolling position
	ScrollInfo.nMax = m_ScrollWindow.bottom-m_RectWindow.Height()+38;                      // maximum scrolling position
	ScrollInfo.nPage = 40;                      // the page size of the scroll box
	ScrollInfo.nPos = 0;                       // initial position of the scroll box
	ScrollInfo.nTrackPos = 0;                   // immediate position of a scroll box that the user is dragging
	m_ctrl_vscroll.SetScrollInfo(&ScrollInfo);

	ScrollInfo.cbSize = sizeof(ScrollInfo);     // size of this structure
	ScrollInfo.fMask = SIF_ALL;                 // parameters to set
	ScrollInfo.nMin = 0;                        // minimum scrolling position
	ScrollInfo.nMax = m_ScrollWindow.right-m_RectWindow.Width()+38;       // maximum scrolling position
	ScrollInfo.nPage = 40;                      // the page size of the scroll box
	ScrollInfo.nPos = 0;                       // initial position of the scroll box
	ScrollInfo.nTrackPos = 0;                   // immediate position of a scroll box that the user is dragging
	m_ctrl_hscroll.SetScrollInfo(&ScrollInfo);
}

//....................................................

void CDSShow::DrawPacket(int x, int y, int state,CDC* dc)
{

	double vgap=20;
	double hgap=1;

	//_____Draw Boxes_____

	int ycord; //________18 is the starting offset____________
	int xcord;

	int i;

	CPen* oldpen;
	CBrush* oldbrush;

	CEvent* _event;

	CPen _pen;
	CBrush _brush;


	//_______Draw dark regions__________-

	oldpen=dc->SelectObject(&PenDark);
	oldbrush=dc->SelectObject(&BrushDark);

	for(i=0;i<bwsim.m_nstations;i++)
	dc->Rectangle(35,18+i*30,35+DS_WIDTH,18+i*30+10);

	//____________Draw bright regions__________

	dc->SelectObject(&PenBright);
	dc->SelectObject(&BrushBright);

	for(i=0;i<event_manager.m_npastevents;i++)
	{
		_event=event_manager.m_pastlist[i];
		if(_event->m_event_type==PACKET_FINISH) //_______Time to draw the packet
		{
			ycord=18+30*_event->m_data; //_____Datasource no
			xcord=35+(bwsim.m_currenttime-_event->m_time)/bwsim.m_dsusec;

			_pen.CreatePen(PS_SOLID,1,_event->m_paintcolor);
			_brush.CreateSolidBrush(_event->m_paintcolor);

			dc->SelectObject(_pen);
			dc->SelectObject(_brush);


			dc->Rectangle(xcord,ycord,xcord+_event->m_duration/bwsim.m_dsusec,ycord+10);
							

			_pen.DeleteObject();
			_brush.DeleteObject();
			_pen.Detach();
			_brush.Detach();


		}
	}

	dc->SelectObject(oldpen);
	dc->SelectObject(oldbrush);

}

//....................................................

int CDSShow::DetermineState(int i,int j)
{
	int state;

	/*if(sreg[i][j]==false)
				state=0;
			else
							state=1;

			for(k=0;k<bwsim.m_nstations;k++)
			{
				if(k!=i && sreg[k][j]==true && state==1)
								state=2;
			}*/

		return state;
}

//....................................................

void CDSShow::OnLButtonDblClk(UINT nFlags, CPoint point)
{

	// TODO: Add your message handler code here and/or call default

	short ds=(point.y+m_vscroll)/VGAP;
	AfxMessageBox("My No. = " + bwsim.itos(ds+1)+
		"\nAverage Delay = " + bwsim.dtos(bwsim.m_ds[ds]->m_averagedelay,5)+
		"\nBandwidth = " + bwsim.itos(bwsim.m_ds[ds]->m_bw)+
		"\nPackets Sent = " + bwsim.itos(bwsim.m_ds[ds]->packets_sent)+
		"\nId = " + (bwsim.m_ds[ds]->id)+
		"\n"+bwsim.m_ds[ds]->GetString()+
		"\nRetransmissions : " + bwsim.itos(bwsim.m_ds[ds]->m_retransmissions)+
		"\nDropped : " + bwsim.itos(bwsim.m_ds[ds]->m_dropped)

		);

	CDialog::OnLButtonDblClk(nFlags, point);
}
