// DataSource.cpp: implementation of the CDataSource class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DataSource.h"
#include "bwsim.h"
#include "general.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CBWSim bwsim;

//....................................................

CDataSource::CDataSource()
{
	m_priority=0;
	m_packetheader=0;

	//	m_maxq=100;

	packets_sent=0;
	packets_waiting=0;


	//	m_totalbandwidth=MAX_BW;
	m_packetlength=PACKETSIZE;
	m_protocol="default";
	m_retranspolicy=USUAL;
}

//....................................................

CDataSource::~CDataSource()
{

}

//....................................................

bool CDataSource::CheckId(char * s)
{
	if(strcmp(id,s)==0)
		return true;
	else
		return false;

}

//....................................................

void CDataSource::Set_nms_id(int nid)
{
	nms_id=nid;

}

//....................................................

void CDataSource::SetBW(int _bw)
{
	m_bw=_bw;
}

//....................................................

void CDataSource::SetPriority(short p)
{
	m_priority=p;
}

//....................................................

double CDataSource::GetTimeMult()
{

	//return (1024*m_totalbandwidth)/bw;

	return bwsim.GetTimeMult(m_bw,m_packetlength);

}

//....................................................

CString CDataSource::GetProtocol()
{
	if(m_protocol!="default")
		return m_protocol;
	else
		return bwsim.m_defaultprotocol;

}

//....................................................

double CDataSource::GetQuanta()
{
	return 1;
}

//....................................................

void CDataSource::Dropped(double sent_time)
{
	m_retransmission++;
	m_dropped++;

	if(m_retransmission==1)
		m_packetsentat=sent_time;
}
