// DataSource.h: interface for the CDataSource class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATASOURCE_H__71F69B5A_32BE_11D4_B58F_005004BF2FFA__INCLUDED_)
#define AFX_DATASOURCE_H__71F69B5A_32BE_11D4_B58F_005004BF2FFA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum retransmission_policy {ALPHA,USUAL};

//....................................................

class CDataSource  : public CObject
{

public:
	char id[20];

	//____________STATIC data__________
	//__________NMS info____

	CString m_protocol;
	int nms_id;  //__________id returned by nms____
	short m_pid; //__________Protocol ID____________
	short m_id;

	int m_packetlength;
	double m_packetduration;
	int m_bw;    //___________bw of data source
	int type; //___type of data source
	short m_priority;
	short m_retranspolicy;

	//__________DYNAMIC DATA____

	int packets_waiting;
	long packets_sent;
	double m_averagedelay;
	int m_dropped;
	int m_retransmissions;
	int m_retransmission;

	double m_packetfinishtime;
	double m_packetstarttime;
	double m_packetsentat;

public:
	UINT m_packetheader;
	int m_transbw;


	virtual CString GetString()=0;

	virtual void Dropped(double sent_time);
	double GetQuanta();
	CString GetProtocol();
	virtual double GetTimeMult();
	virtual void Reset()=0;
	void SetPriority(short p);
	void SetBW(int _bw);
	virtual void  Set_nms_id(int nid);
	virtual bool CheckId(char *s);
	virtual bool IsPacketAvail(double current_time)=0;
	virtual bool IsPacketBurst(double current_time)=0;
	virtual void ScheduleNextPacket(double time)=0;
	virtual int PacketsWaiting(double current_time)=0;
	virtual void SendPacket()=0;

	//_______For Poisson Class
	//virtual void SetLambda(double lamb);
	//virtual void Reset();

	//________For video class
	//virtual void Send();

	CDataSource();
	virtual ~CDataSource();

};

#endif // !defined(AFX_DATASOURCE_H__71F69B5A_32BE_11D4_B58F_005004BF2FFA__INCLUDED_)
