// Display.cpp : implementation file
//

#include "stdafx.h"
#include "BWSim.h"
#include "Display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisplay dialog

extern CBWSim bwsim;
extern CAutomation m_auto;

//....................................................

CDisplay::CDisplay(CWnd* pParent /*=NULL*/)
: CDialog(CDisplay::IDD, pParent)
{

	//{{AFX_DATA_INIT(CDisplay)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

}

//....................................................

void CDisplay::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CDisplay)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP

}

BEGIN_MESSAGE_MAP(CDisplay, CDialog)
	//{{AFX_MSG_MAP(CDisplay)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

	/////////////////////////////////////////////////////////////////////////////
	// CDisplay message handlers

//....................................................

BOOL CDisplay::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	GetDlgItem(IDC_WINDOW)->GetWindowRect(&m_RectWindow);
	ScreenToClient(&m_RectWindow);
	m_RectWindow.DeflateRect(2,2);

	//____Init Pens_____________

	PenDark.CreatePen(PS_SOLID,1,RGB(20,57,5));
	PenBright.CreatePen(PS_SOLID,1,RGB(152,245,115));
	PenClash.CreatePen(PS_SOLID,1,RGB(248,139,50));

	BrushDark.CreateSolidBrush(RGB(20,57,5));
	BrushBright.CreateSolidBrush(RGB(152,245,115));
	BrushClash.CreateSolidBrush(RGB(248,139,50));

	//___________Create display font________

	m_displayfont.CreatePointFont(70,"Arial",NULL);
	m_smallfont.CreatePointFont(70,"Arial",NULL);

	m_ScrollWindow.left=0;
	m_ScrollWindow.top=0;
	m_ScrollWindow.right=m_RectWindow.Width();
	m_ScrollWindow.bottom=m_RectWindow.Height();

	return TRUE;  // return TRUE unless you set the focus to a control

	// EXCEPTION: OCX Property Pages should return FALSE

}

//....................................................

void CDisplay::OnPaint()
{

	// TODO: Add your message handler code here

	CPaintDC pDC(this);
	CMemDC memDC( &pDC, m_ScrollWindow, m_RectWindow, &m_BufferBackground );
	CDC* dc=memDC.GetSafeCDC();

	dc->FillRect(m_ScrollWindow,&BrushDark);

	// TODO: Add your message handler code here
	//________________Draw the packet window_____________

	CPen PenRed(PS_SOLID,1,RGB(255,0,0));
	CBrush BrushRed(RGB(255,0,0));

	//____________Set Text attributes_______________

	dc->SelectObject(m_smallfont);
	dc->SetTextColor(RGB(255,0,0));
	dc->SetBkMode(TRANSPARENT);

	//itoa(int(bwsim.m_currenttime),buffer[0],10);

	dc->TextOut(2,2,CString("Current time : ") + bwsim.itos(int(bwsim.m_currenttime)));
	dc->TextOut(2,22,CString("Packets Attempted : ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_attempted)));

	//	dc->TextOut(2,32,CString("Bytes Attempted : ") + bwsim.itos(int(bwsim.m_global_performance.m_bytes_attempted)));

	dc->TextOut(2,32,CString("Packets Sent : ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_sent)));

	//	dc->TextOut(2,62,CString("Bytes Sent : ") + bwsim.itos(int(bwsim.m_global_performance.m_bytes_sent)));

	dc->TextOut(2,42,CString("Max packets possible: ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_ideal)));

	//________Average Thoroghput

	double _t=0;
	if(bwsim.m_global_performance.m_packets_ideal!=0)
		_t=bwsim.m_nms.m_bwallocated*bwsim.m_global_performance.m_bytes_sent/bwsim.m_global_performance.m_bytes_ideal;

	int _length=bwsim.itos(bwsim.m_nms.m_bwallocated).GetLength();
	dc->TextOut(2,52,"BW Allocated : "+bwsim.itos(bwsim.m_nms.m_bwallocated)+"  Av.Thoroughput(kbps): "+bwsim.dtos(_t,_length+1));
	dc->TextOut(2,62,CString("Percentage: ")+bwsim.dtos(_t*100/bwsim.m_nms.m_bwallocated,4));
	if(m_auto.started)
	{
		dc->TextOut(2,82,"Automation Progress: " + bwsim.itos(m_auto.current_trial)+"/"+bwsim.itos(m_auto.trials));
		dc->TextOut(2,92,"Trial Duration: " + bwsim.itos(m_auto.duration));

	}

	//___________Now show statistics___

	//___________Fil with black color
	//	CBrush Brush(BrushDark);

	// Do not call CDialog::OnPaint() for painting messages

	memDC.CopyToScreen(0,0,0);

}
