// EventManager.cpp: implementation of the CEventManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BWSim.h"
#include "EventManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CEvent gevent;
extern CBWSim bwsim;

//....................................................

CEventManager::CEventManager()
{

	//	m_eventlist.SetSize(500);

	m_nevents=0;
	m_npastevents=0;

	m_color_red=RGB(255,0,0);
	m_color_lightred=RGB(255,128,128);

	m_color_blue=RGB(0,0,255);
	m_color_green=RGB(152,245,115);
	m_color_white=RGB(255,255,255);
	m_color_paleyellow=RGB(255,255,128);
	m_color_lightblue=RGB(0,128,255);
	m_color_orange=RGB(255,128,0);
	m_color_lightgrey=RGB(192,192,192);



}

//....................................................

CEventManager::~CEventManager()
{

}

//....................................................

void CEventManager::AddEvent(CEvent* event)
{
	m_eventlist.Add(event);
	m_nevents++;

}

//....................................................

CEvent* CEventManager::GetNextEvent()
{
	CEvent* event;
	int id=0;

	double min_time=m_eventlist[0]->m_time;
	event=m_eventlist[0];

	for(int i=1;i<m_nevents;i++)
	{
		if(m_eventlist[i]->m_time<min_time)
		{
			event=m_eventlist[i];
			min_time=min(min_time,event->m_time);
			id=i;
		}
	}

	gevent=*event;
	m_eventlist.RemoveAt(id); //_____Not deleting the address___

	//delete event;

	m_nevents--;

	//__________Now add to the past event list________

	m_pastlist.Add(event);
	m_npastevents++;

	double starttime=bwsim.m_currenttime-max(DS_WIDTH,BW_WIDTH)*bwsim.m_dsusec;
	CEvent* _event;

	//________Remove the prev stale events__________

	for(i=0;i<m_npastevents;i++)
	{
		_event=m_pastlist[i];
		if(_event->m_time<starttime)
		{
			delete _event;
			m_pastlist.RemoveAt(i);
			m_npastevents--;
			i--;
		}
		else
			break;
	}

	return (&gevent);

}

//....................................................

void CEventManager::Reset()
{
	Cleanup();
}

//....................................................

void CEventManager::Cleanup()
{
	int i;
	for(i=0;i<m_nevents;i++)
	delete m_eventlist[i];
	for(i=0;i<m_npastevents;i++)
	delete m_pastlist[i];

	m_eventlist.RemoveAll();
	m_pastlist.RemoveAll();
	m_nevents=0;
	m_npastevents=0;

}
