// FDMA.cpp: implementation of the CFDMA class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "bwsim.h"
#include "FDMA.h"
#include "bwsim.h"
#include "event.h"
#include "eventmanager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CBWSim bwsim;
extern CEventManager event_manager;

//....................................................

CFDMA::CFDMA()
{

}

//....................................................

CFDMA::~CFDMA()
{

}

//....................................................

bool CFDMA::Init(double current_time)
{
	int _bwn=0; //_____band width needed__________
	int i=0;

	for(i=0;i<MAX_NSRC;i++)
	{
		if(IsAllocated[i])
		{
			m_dsbw.SetAt(i,_bwn);
			_bwn+=ds_array[i]->m_transbw;
		}
	}

	if(bw_avail<_bwn)
	{
		return false;
	}
	m_nchannels=no_ds;

	return true;
}

//....................................................

void CFDMA::Send(double current_time)
{

	if(bwsim.m_currentevent->m_event_type==PACKET_SEND_END)
	{

		//__________Do statistics part___

		int _id=bwsim.m_currentevent->m_data;
		ds_array[_id]->SendPacket();

	}
	else //________Schedule this packet for some other time____
		{
		CEvent* _event=bwsim.m_currentevent;
		int _id=bwsim.m_ds[_event->m_data]->nms_id;  //_______Its position in IsAllocated Array

		//_____i contains the slot no.

		double _slottime=current_time;

		int _bwlower;
		m_dsbw.Lookup(_id,_bwlower);

		CEvent* _event1=new CEvent;

		_event1->m_event_type=PACKET_SEND_END;
		_event1->m_data=_id;
		_event1->m_bwlower=bwind_start+_bwlower;
		_event1->m_bwupper=_event1->m_bwlower+ds_array[_id]->m_transbw-1;;
		_event1->m_duration=ds_array[_id]->GetTimeMult();
		_event1->m_origintime=bwsim.m_currentevent->m_origintime;
		_event1->m_time=_slottime+_event1->m_duration;

		event_manager.AddEvent(_event1);
	}

	/*
			int i,j,k;
			int _bwcount=0;

			for(i=0;i<MAX_NSRC;i++)
			{
				if(IsAllocated[i])
				{
					if(ds_array[i]->IsPacketAvail(current_time))
					{
						
						k=bwind_start+_bwcount;
						for(j=0;j<ds_array[i]->bw;j++)
						{
							bw_used[k++]=i;
						}
						ds_array[i]->SendPacket();
					}
					_bwcount+=ds_array[i]->bw;

				}
			}*/

	}

//....................................................

void CFDMA::Finish(double current_time)
{

}

//....................................................

int CFDMA::GetBWRequired()
{
	return no_ds*64;
}
