// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "BWSim.h"
#include "error.h"

#include "MainFrm.h"
#include "EventManager.h"
#include "event.h"

//Dialogs

#include "DSAdd.h"
#include "DSShow.h"

#include "BWShow.h"
#include "Dialog1.h"
#include "Display.h"
#include "Zoom.h"
#include "Poisson.h"
#include "Aloha.h"

#include "mmsystem.h"
#include <sys/types.h>
#include <sys/stat.h>

//#include "DSStats.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

extern CBWSim bwsim;
extern CAutomation m_auto;

extern CDSAdd dlg_dsadd;
extern CDSShow dlg_dsshow;

extern CBWShow dlg_bwshow;
extern CDialog1 dlg_list;
extern CDisplay dlg_display;
extern CZoom dlg_zoom;

extern CError error;
extern CEventManager event_manager;

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_DSADD, OnDsadd)
	ON_COMMAND(ID_START, OnStart)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_PAUSE, OnPause)
	ON_WM_TIMER()
	ON_COMMAND(ID_DSSHOW, OnDsshow)
	ON_COMMAND(ID_BWSHOW, OnBwshow)
	ON_COMMAND(ID_STATSSHOW, OnStatsshow)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_COMMAND(ID_OPTIONS_VSET, OnOptionsVset)
	ON_COMMAND(ID_AUTOMATE, OnAutomate)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

	/////////////////////////////////////////////////////////////////////////////
	// CMainFrame construction/destruction

//....................................................

CMainFrame::CMainFrame()
{

	// TODO: add member initialization code here

}

//....................................................

CMainFrame::~CMainFrame()
{
}

//....................................................

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_TOOLBAR1))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	//_______Read BWSim settings______

	bwsim.m_dsusec=AfxGetApp()->GetProfileInt("BWSim Setup","m_dsusec",10);
	bwsim.m_bwusec=AfxGetApp()->GetProfileInt("BWSim Setup","m_bwusec",10);
	bwsim.m_dswidth=AfxGetApp()->GetProfileInt("BWSim Setup","m_dswidth",200);
	bwsim.m_bwwidth=AfxGetApp()->GetProfileInt("BWSim Setup","m_bwwidth",200);
	bwsim.m_defaultprotocol=AfxGetApp()->GetProfileString("BWSim Setup","m_defaultprotocol","none");

	CRect _rect;

	dlg_dsadd.Create(IDD_DSADD,this);

	//dlg_dsadd.ShowWindow(SW_SHOWNORMAL);

	dlg_dsshow.Create(IDD_DSSHOW,this);
	dlg_dsshow.ShowWindow(SW_SHOWNORMAL);

	//	dlg_simulset.Create(IDD_SIMSET,this);
	//	dlg_simulset.ShowWindow(SW_SHOWNORMAL);

	dlg_bwshow.Create(IDD_BWSHOW,this);
	dlg_bwshow.ShowWindow(SW_SHOWNORMAL);

	//	dlg_list.Create(IDD_DIALOG1,this);
	//	dlg_list.ShowWindow(SW_SHOWNORMAL);

	dlg_display.Create(IDD_DISPLAY,this);
	dlg_display.ShowWindow(SW_SHOWNORMAL);

	dlg_zoom.Create(IDD_ZOOM,this);
	dlg_zoom.ShowWindow(SW_SHOWNORMAL);

	_rect.left=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsadd.left",0);
	_rect.top=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsadd.top",0);
	_rect.right=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsadd.right",0);
	_rect.bottom=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsadd.bottom",0);
	if(_rect.Height()>0 && _rect.Width()>0)
		dlg_dsadd.MoveWindow(_rect);

	_rect.left=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsshow.left",0);
	_rect.top=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsshow.top",0);
	_rect.right=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsshow.right",0);
	_rect.bottom=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_dsshow.bottom",0);
	if(_rect.Height()>0 && _rect.Width()>0)
		dlg_dsshow.MoveWindow(_rect);

	_rect.left=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_bwshow.left",0);
	_rect.top=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_bwshow.top",0);
	_rect.right=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_bwshow.right",0);
	_rect.bottom=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_bwshow.bottom",0);
	if(_rect.Height()>0 && _rect.Width()>0)
		dlg_bwshow.MoveWindow(_rect);

	_rect.left=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_zoom.left",0);
	_rect.top=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_zoom.top",0);
	_rect.right=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_zoom.right",0);
	_rect.bottom=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_zoom.bottom",0);
	if(_rect.Height()>0 && _rect.Width()>0)
		dlg_zoom.MoveWindow(_rect);

	_rect.left=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_display.left",0);
	_rect.top=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_display.top",0);
	_rect.right=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_display.right",0);
	_rect.bottom=AfxGetApp()->GetProfileInt("Dialog Positions","dlg_display.bottom",0);
	if(_rect.Height()>0 && _rect.Width()>0)
		dlg_display.MoveWindow(_rect);

	return 0;
}

//....................................................

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{

	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

	/////////////////////////////////////////////////////////////////////////////
	// CMainFrame diagnostics

#ifdef _DEBUG

//....................................................

void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

//....................................................

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

	/////////////////////////////////////////////////////////////////////////////
	// CMainFrame message handlers

//....................................................

void CMainFrame::OnStart()
{

	// TODO: Add your command handler code here
	//__________Must clean up before you start__

	if(bwsim.m_start)
		return;

	OnStop();
	InitSim();
	StartSim();
	return;
}

//....................................................

void CMainFrame::OnStop()
{

	// TODO: Add your command handler code here

	bwsim.m_start=false;
	bwsim.m_paused=false;

	dlg_dsadd.m_add.EnableWindow(true);
	dlg_dsadd.m_del.EnableWindow(true);
}

//....................................................

void CMainFrame::OnPause()
{

	// TODO: Add your command handler code here

	if(bwsim.m_start==false)
	{
		AfxMessageBox("Please start the data sources first !");
		return;
	}
	bwsim.m_paused=!bwsim.m_paused;
}

//....................................................

void CMainFrame::OnTimer(UINT nIDEvent)
{

	if(nIDEvent==200)
	{
		KillTimer(200);
		m_timer=false;
	}
	else if(nIDEvent==201)
	{
		m_auto.time++;

		if(bwsim.m_currenttime>m_auto.duration)
		{
			OnStop();
			KillTimer(201);
		}
	}
	else if(nIDEvent==202)
	{
		if(dlg_display.IsWindowVisible())
		{
			dlg_display.InvalidateRect(dlg_display.m_RectWindow,false);
			dlg_display.UpdateWindow();
		}
	}

}

//....................................................

void CMainFrame::OnDsshow()
{

	// TODO: Add your command handler code here

	dlg_dsshow.ShowWindow(SW_SHOWNORMAL);

}

//....................................................

void CMainFrame::OnBwshow()
{

	// TODO: Add your command handler code here

	dlg_bwshow.ShowWindow(SW_SHOWNORMAL);

}

//....................................................

void CMainFrame::OnStatsshow()
{

	// TODO: Add your command handler code here

	dlg_display.ShowWindow(SW_SHOWNORMAL);

}

//....................................................

void CMainFrame::OnDsadd()
{

	// TODO: Add your command handler code here

	dlg_dsadd.ShowWindow(SW_SHOWNORMAL);
}

//....................................................

void CMainFrame::OnDestroy()
{

	CMDIFrameWnd::OnDestroy();

	// TODO: Add your message handler code here

}

//....................................................

void CMainFrame::OnClose()
{

	// TODO: Add your message handler code here and/or call default

	CRect _rect;

	dlg_dsadd.GetWindowRect(_rect);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsadd.left",_rect.left);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsadd.top",_rect.top);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsadd.right",_rect.right);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsadd.bottom",_rect.bottom);

	dlg_dsshow.GetWindowRect(_rect);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsshow.left",_rect.left);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsshow.top",_rect.top);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsshow.right",_rect.right);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_dsshow.bottom",_rect.bottom);

	dlg_bwshow.GetWindowRect(_rect);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_bwshow.left",_rect.left);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_bwshow.top",_rect.top);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_bwshow.right",_rect.right);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_bwshow.bottom",_rect.bottom);

	dlg_zoom.GetWindowRect(_rect);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_zoom.left",_rect.left);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_zoom.top",_rect.top);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_zoom.right",_rect.right);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_zoom.bottom",_rect.bottom);

	dlg_display.GetWindowRect(_rect);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_display.left",_rect.left);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_display.top",_rect.top);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_display.right",_rect.right);
	AfxGetApp()->WriteProfileInt("Dialog Positions","dlg_display.bottom",_rect.bottom);

	AfxGetApp()->WriteProfileInt("BWSim Setup","m_dsusec",bwsim.m_dsusec);
	AfxGetApp()->WriteProfileInt("BWSim Setup","m_bwusec",bwsim.m_bwusec);
	AfxGetApp()->WriteProfileInt("BWSim Setup","m_dswidth",bwsim.m_dswidth);
	AfxGetApp()->WriteProfileInt("BWSim Setup","m_bwwidth",bwsim.m_bwwidth);
	AfxGetApp()->WriteProfileString("BWSim Setup","m_defaultprotocol",bwsim.m_defaultprotocol);

	CMDIFrameWnd::OnClose();
}

//....................................................

void CMainFrame::OnOptionsVset()
{

	// TODO: Add your command handler code here

	dlg_zoom.ShowWindow(SW_SHOWNORMAL);

}

//....................................................

void CMainFrame::OnAutomate()
{

	// TODO: Add your command handler code here

	if(m_auto.started)
	{
		m_auto.started=false;
		return;
	}

	if(bwsim.m_start)
		return;

	if(bwsim.m_nstations>0)
	{
		AfxMessageBox("Some data sources already present !");
		return;
	}

	CStdioFile _file;
	if(_file.Open("c:\\results.txt",CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText | CFile::modeWrite)==0)
	{
		AfxMessageBox("Error writing to results file");
		return;
	}

	CStdioFile _dfile;
	if(_dfile.Open("c:\\data.txt",CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText | CFile::modeWrite)==0)
	{
		AfxMessageBox("Error writing to graph file");
		return;
	}

	int i,j,k;

	//____________________Set all the settings here___________________

	//________Automation related settings

	int _stations=100;
	m_auto.m_title="Th. vs Load - at 128 kbps";
	m_auto.duration=1500000.0;
	m_auto.trials=35;
	m_auto.time=0;
	m_auto.started=true;

	//__________Data sources related settings____

	double _l1=double(16)/(1000*_stations);
	double _lambdaarray[12]={
		0.05*_l1,
		0.1*_l1,
		0.2*_l1,
		0.5*_l1,
		1*_l1,
		1.1*_l1,
		1.2*_l1,
		1.3*_l1,
		2*_l1,
		3*_l1,
		4*_l1,
		5*_l1
		};

	double _lambda=0;
	double _slotted=true;
	double _alpha=(1.0/_stations)*1.5;
	bwsim.m_defaultprotocol="aloha";

	//__________________________________________________________________________________________
	//__________First add the sources

	for(i=0;i<_stations;i++)
	{

		//__________Make the required data source with the required properties____

		CDataSource* _t=new CPoisson;
		_t->type=1;
		bwsim.AddDataSource(_t);
	}

	_file.Seek(0,CFile::end);
	_dfile.Seek(0,CFile::end);

	_file.WriteString("\n\n\n---------------AUTOMATION RESULTS----------------");
	_file.WriteString("\n\n\nTITLE : "+m_auto.m_title);
	_file.WriteString("\n\nNo. of trials : " + bwsim.itos(m_auto.trials));
	_file.WriteString("\n----------------------------------------------");

	_dfile.WriteString("\n\n\n---------------AUTOMATION RESULTS----------------");
	_dfile.WriteString("\n\n\nTITLE : "+m_auto.m_title+"\n\n");
	_dfile.WriteString("\nLoad		Th.\n");

	for(i=0;i<m_auto.trials;i++)
	{

		m_auto.current_trial=i+1;

		//__________Prepare for simualation

		if(_lambda<1)
			_lambda+=0.05;
		else
			_lambda+=0.2;

		//_lambda=1;
		//_alpha+=0.005;
		//________Set the parameters of the data sources____

		for(j=0;j<bwsim.m_nstations;j++)
		{
			((CPoisson*)bwsim.m_ds[j])->SetLambda(_lambda*_l1);
			((CPoisson*)bwsim.m_ds[j])->m_slotted=_slotted;
			((CPoisson*)bwsim.m_ds[j])->m_retranspolicy=USUAL;

			//___Set protocol parameters
			//	bwsim.m_nms.GetProtocol(bwsim.m_ds[j])->m_autobw=false;
			//	bwsim.m_nms.GetProtocol(bwsim.m_ds[j])->bw_avail=64*_stations/2;

		}

		//_______Start of simulation

		bwsim.m_currenttime=0;
		SetTimer(201,1000,NULL);
		InitSim();

		//__________Set protocol parameters___

		for(j=0;j<bwsim.m_nstations;j++)
		{
			if(bwsim.m_ds[j]->GetProtocol()=="aloha")
				((CAloha*)bwsim.m_nms.GetProtocol(bwsim.m_ds[j]))->alpha=_alpha;
		}

		//__________End protocol parameters

		StartSim();

		KillTimer(201);

		//___________End of simulation
		//___________Save results

		_file.WriteString("\nStart of Run : "+bwsim.itos(i+1));
		_file.WriteString("\nProtocol : "+bwsim.m_defaultprotocol+
			"\nNo. of sources	:"+bwsim.itos(_stations));

		_file.WriteString("\nLambda : "+bwsim.dtos(_lambda*_l1,6));
		_file.WriteString("\nCollective Load ( sum of lambdas ) : "+bwsim.dtos(_lambda,6));

		_file.WriteString(CString("\nSlotted : ")+ ((_slotted) ? "Yes" : "No"));

		_file.WriteString(CString("\nCurrent time : ") + bwsim.itos(int(bwsim.m_currenttime)));
		_file.WriteString(CString("\nPackets Attempted : ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_attempted)));
		_file.WriteString(CString("\nPackets Sent : ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_sent)));

		_file.WriteString(CString("\nMax packets possible: ") + bwsim.itos(int(bwsim.m_global_performance.m_packets_ideal)));

		//________Average Thoroghput

		double _t=0;
		if(bwsim.m_global_performance.m_packets_ideal!=0)
			_t=bwsim.m_nms.m_bwallocated*bwsim.m_global_performance.m_packets_sent/bwsim.m_global_performance.m_packets_ideal;

		int _length=bwsim.itos(bwsim.m_nms.m_bwallocated).GetLength();

		_file.WriteString("\nBW Allocated : "+bwsim.itos(bwsim.m_nms.m_bwallocated)+"  Av.Thoroughput(kbps): "+bwsim.dtos(_t,_length+1));
		_file.WriteString(CString("\nPercentage: ")+bwsim.dtos(_t*100/bwsim.m_nms.m_bwallocated,4));
		_file.WriteString("\n\n---------------------------");

		//_____Compute average delay

		double _totaldelay=0;
		for(j=0;j<bwsim.m_nstations;j++)
		{
			_totaldelay+=bwsim.m_ds[j]->m_averagedelay;
		}
		double _avdelay=_totaldelay/bwsim.m_nstations;

		//_____Here graph values are written
		//_______Write x y values

		_dfile.WriteString("\n"+bwsim.dtos(_lambda,7)+"		"+bwsim.dtos(_t*100/bwsim.m_nms.m_bwallocated,4));

		//_dfile.WriteString("\n"+bwsim.dtos(_lambda,7)+"		"+bwsim.dtos(_avdelay,4));

		if(!m_auto.started)
		{
			_file.WriteString("\n\nInterrupted !!!");
			AfxMessageBox("Automation Interrupted");
			break;
		}

		//__________One simulation run done___

	}

	_file.WriteString("\n\nTime Taken (in seconds): " +bwsim.itos(m_auto.time));

	_file.Close();
	_dfile.Close();

	//________Now delete all data sources

	while(bwsim.DeleteDataSource(0))
		{};
	m_auto.Reset();

	//________Alarm system

	CString sound;
	struct _stat buf;
	sound="c:\\finish.wav";
	if(_stat(sound,&buf))
		return;

//	sndPlaySound(NULL,SND_SYNC);
//	sndPlaySound(sound, SND_SYNC & ~SND_NOSTOP);

//	sndPlaySound(NULL,SND_SYNC);
//	sndPlaySound(sound, SND_SYNC & ~SND_NOSTOP);
}

//....................................................

void CMainFrame::InitSim()
{
	int i,j;

	//____________data setup

	bwsim.m_start=true;
	bwsim.m_paused=false;
	bwsim.m_currenttime=0;
	m_timer=false;
	bwsim.m_lastevent=0;

	event_manager.Reset();
	bwsim.m_nms.Reset();
	bwsim.Reset();

	//________Disable bad buttons_______

	dlg_dsadd.m_add.EnableWindow(false);
	dlg_dsadd.m_del.EnableWindow(false);

	dlg_dsshow.ReInit(bwsim.m_nstations);
	dlg_bwshow.ReInit();

	//	m_wtime=1/m_lambda;

	//_____________Init all the display dialogs________________

	//_____Repaint m_RectSample____

	dlg_dsshow.InvalidateRect(dlg_dsshow.m_RectWindow);
	dlg_dsshow.UpdateWindow();

	dlg_bwshow.InvalidateRect(dlg_bwshow.m_RectWindow);
	dlg_bwshow.UpdateWindow();

	//__________Start Main Process________

	//____________________Simulation Setup__________

	if(bwsim.m_nstations==0)
	{
		AfxMessageBox("Please add data sources first");
		return;
	}

	//____________Add data sources to NMS______________

	for(i=0;i<bwsim.m_nstations;i++)
	{
		bwsim.m_ds[i]->Set_nms_id(bwsim.m_nms.AddDataSource(bwsim.m_ds[i]));
		bwsim.m_ds[i]->Reset();


	}

	if(bwsim.m_nms.AssignProtocols(bwsim.m_currenttime)==false)
	{
		error.DisplayError();
		return;
	}

	for(i=0;i<bwsim.m_nstations;i++)
	{

		//____________--Add packet events - this is necessary to get the events starting____________

		CEvent* _event=new CEvent;
		_event->m_event_type=PACKET_FINISH;
		(_event->m_origintime)=_event->m_time=bwsim.m_ds[i]->m_packetfinishtime;
		_event->m_data=i;
		_event->m_duration=bwsim.m_ds[i]->GetTimeMult();
		event_manager.AddEvent(_event);
	}

}

//....................................................

void CMainFrame::StartSim()
{

	//_____________Get the first event and get going___

	bwsim.m_currentevent=event_manager.GetNextEvent();
	bwsim.m_currenttime=bwsim.m_currentevent->m_time;

	SetTimer(202,2000,NULL);

	//	dlg_list.m_list.ResetContent();
	//_______________________________________
	//________Start main loop________________
	//_______________________________________

	CArray<int , int&> current_sources;
	current_sources.SetSize(bwsim.m_nstations);
	short _thistime=0;
	CEvent _ev;

	int i,j;

	while(bwsim.m_start)
	{

		//____________Cool trick to process messages___

		MSG message;
		if(::PeekMessage(&message,NULL,0,0,PM_REMOVE))
		{
			::TranslateMessage(&message);
			::DispatchMessage(&message);
		}

		if(m_timer)
			continue;

		if(bwsim.m_paused)
			continue;

		if(bwsim.m_currentevent->m_event_type==PACKET_START)
		{

			//_______Update DSShow display

		}

		//_____Process all packets till now

		if(bwsim.m_currentevent->m_event_type==PACKET_FINISH)
		{

			//__________Update display

			if(dlg_dsshow.IsWindowVisible() && bwsim.m_currentevent->m_event_type==PACKET_FINISH)
			{
				dlg_dsshow.InvalidateRect(dlg_dsshow.m_RectWindow,false);
				dlg_dsshow.UpdateWindow();
			}

			int i=bwsim.m_currentevent->m_data;

			//_____Call the corresponding protocol____
			bwsim.m_global_performance.m_packets_attempted++;
			bwsim.m_global_performance.m_bytes_attempted+=bwsim.m_ds[i]->m_packetlength/8;


			bwsim.m_nms.Send(bwsim.m_currenttime,bwsim.m_ds[i]->m_pid);

			//_____After calling Send request schedule next packet

			bwsim.m_ds[i]->ScheduleNextPacket(bwsim.m_currenttime);

			CEvent* _event=new CEvent;
			_event->m_event_type=PACKET_FINISH;
			_event->m_origintime=(_event->m_time=bwsim.m_ds[i]->m_packetfinishtime);
			_event->m_data=i;
			_event->m_duration=bwsim.m_ds[i]->GetTimeMult();
			_event->m_packetheader=bwsim.m_ds[i]->m_packetheader;
		
			if((_event->m_packetheader & 1))
				_event->m_paintcolor=event_manager.m_color_paleyellow;

			event_manager.AddEvent(_event);

			//current_sources.Add(i);
			//_thistime++;

		}

		if(bwsim.m_currentevent->m_event_type==PACKET_SEND)
		{

		}

		if(bwsim.m_currentevent->m_event_type==PACKET_SEND_END)
		{


			if(dlg_bwshow.IsWindowVisible() && bwsim.m_currentevent->m_event_type==PACKET_SEND_END)
			{
				dlg_bwshow.InvalidateRect(dlg_bwshow.m_RectWindow,false);
				dlg_bwshow.UpdateWindow();
			}

			//____________Send the packet finally__________________

			int i=bwsim.m_currentevent->m_data;

			bwsim.m_global_performance.m_packets_sent++;
			bwsim.m_global_performance.m_bytes_sent+=bwsim.m_ds[i]->m_packetlength/8;

			bwsim.m_nms.Send(bwsim.m_currenttime,bwsim.m_ds[i]->m_pid);
		}

		if(bwsim.m_currentevent->m_event_type==PACKET_NOTIFY)
		{
			int i=bwsim.m_currentevent->m_data;
			bwsim.m_nms.Send(bwsim.m_currenttime,bwsim.m_ds[i]->m_pid);
		}

		bwsim.m_global_performance.m_packets_ideal=((bwsim.m_currenttime/1000)*(bwsim.m_nms.m_bwallocated*1024))/PACKETSIZE;
		//bwsim.m_global_performance.m_bytes_ideal=(bwsim.m_global_performance.m_packets_ideal*(PACKETSIZE/8));
		bwsim.m_global_performance.m_bytes_ideal=(((bwsim.m_nms.m_bwallocated*1024)/8)*(bwsim.m_currenttime/1000));

		//		double _t=bwsim.m_currenttime;

		bwsim.m_currentevent=event_manager.GetNextEvent();
		bwsim.m_currenttime=bwsim.m_currentevent->m_time;

		//____________Shift of time_____
		/*	if(bwsim.m_currenttime>_t)
						{
						for(j=0;j<_thistime;j++)
						{
						i=current_sources[j];
						//_______Schedule next packet
						bwsim.m_ds[i]->ScheduleNextPacket(_t);
						
						  CEvent* _event=new CEvent;
						  _event->m_event_type=PACKET_FINISH;
						  _event->m_origintime=(_event->m_time=bwsim.m_ds[i]->m_packetfinishtime);
						  _event->m_data=i;
						  _event->m_duration=bwsim.m_ds[i]->GetTimeMult();
						  event_manager.AddEvent(_event);
						  
							}
							current_sources.RemoveAll();
							_thistime=0;
							
						}*/

			if(bwsim.m_delay>=30)
		{
			SetTimer(200,bwsim.m_delay,NULL);
			m_timer=true;
		}
	}

	event_manager.Cleanup();
	KillTimer(202);
}
