// TDMA.cpp: implementation of the CTDMA class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "bwsim.h"
#include "TDMA.h"

#include "EventManager.h"
#include "event.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CEventManager event_manager;
extern CBWSim bwsim;

//....................................................

CTDMA::CTDMA()
{

}

//....................................................

CTDMA::~CTDMA()
{

}

//....................................................

bool CTDMA::Init(double current_time)
{
	if(no_ds>10)
	{
		return false;
	}

	m_starttime=current_time;
	m_nslots=no_ds;

	//_______Now assign the slots to data sources

	int i,j;
	j=0;
	double _s=0;
	for(i=0;i<MAX_NSRC;i++)
	{
		if(IsAllocated[i]==1)
		{
			m_slot_assignment[j++]=i;
			ds_array[i]->m_transbw=bw_avail;
//			ds_array[i]->m_packetduration=
//				bwsim.GetTimeMult(ds_arrads_array[i]->m_packetlength

			//________Starting time___

			m_slottimings.SetAt(i,_s);
			_s+=bwsim.GetTimeMult(bw_avail);
		}
	}
	return true;
}

//....................................................

void CTDMA::Send(double current_time)
{

	if(bwsim.m_currentevent->m_event_type==PACKET_SEND_END)
	{

		//__________Do statistics part___

		int _id=bwsim.m_currentevent->m_data;
		ds_array[_id]->SendPacket();

	}
	else if(bwsim.m_currentevent->m_event_type==PACKET_FINISH) //________Schedule this packet for some other time____
	{
		CEvent* _event=bwsim.m_currentevent;
		int _id=bwsim.m_ds[_event->m_data]->nms_id;  //_______Its position in IsAllocated Array

		//_____i contains the slot no.

		double _frametime=bwsim.GetTimeMult(bw_avail)*m_nslots;
		double _s;
		m_slottimings.Lookup(_id,_s);

		double _slottime=m_starttime+int((current_time-m_starttime)/_frametime)*_frametime+_s;
		while(_slottime<current_time)
			_slottime+=_frametime;

		//		AfxMessageBox("currenttime : "+bwsim.dtos(current_time)+ " slottime : " + bwsim.dtos(_slottime));

		//		if(_slottime<current_time)
		//			AfxMessageBox("Problem");

		CEvent* _event1=new CEvent;

		_event1->m_event_type=PACKET_SEND_END;
		_event1->m_data=_id;
		_event1->m_bwlower=bwind_start;
		_event1->m_bwupper=bwind_start+bw_avail-1;
		_event1->m_duration=bwsim.GetTimeMult(bw_avail); //_____Duration of this packet
		_event1->m_origintime=bwsim.m_currentevent->m_origintime;
		_event1->m_time=_slottime+_event1->m_duration;

		//		if((_event1->m_time-current_time)<124)
		//			AfxMessageBox("Problem");

		event_manager.AddEvent(_event1);
	}

}

//....................................................

void CTDMA::Finish(double current_time)
{

}

//....................................................

int CTDMA::GetBWRequired()
{
	return no_ds*64;
}
