// FHOP.h: interface for the CVCFHOP class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FHOP_H__A612BF33_33B2_11D4_B594_005004BF2FFA__INCLUDED_)
#define AFX_FHOP_H__A612BF33_33B2_11D4_B594_005004BF2FFA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef PROTOCOL
#include "protocol.h"
#endif

//....................................................

class CVCFHOP : public CProtocol
{
public:
	bool IsFreqReserved(int freq);
	void ClearChannel(int freq,int ds);
	int GetRandomFreq(double m_currenttime);
	int GetRandomChannel(double current_time);
	virtual int GetBWRequired();

	virtual void Finish(double current_time);
	virtual void Send(double current_time);
	virtual bool Init(double current_time);
	CVCFHOP();
	virtual ~CVCFHOP();

	//_____Data members

	CMap<int,int,bool,bool> m_occupied;
	CMap<int,int,bool,bool> m_clashed;
	CMap<int,int,int,int> m_dsbw;
	CMap<int,int,double,double> m_endtime;
	CMap<int,int,int,int> m_randfreq;
	CMap<int,int,int,int> m_freqwidth;

	CMap<int,int,int,int> m_pastfreqid;
	CMap<int,int,int,int> m_channelfrequency;
	CMap<int,int,double,double> m_blockedchannels;
	

	short m_srcperchannel;
	int m_maxrand;

};

#endif // !defined(AFX_FHOP_H__A602BF33_33B2_11D4_B594_005004BF2FFA__INCLUDED_)
